// Generated by LiveScript 1.5.0
var ref$, cyan, green, red, inquirer, fs, yaml, Logger, merge, N, version, path, tmplconv, yamlCutter, data, questions;
ref$ = require('chalk'), cyan = ref$.cyan, green = ref$.green, red = ref$.red;
inquirer = require('inquirer');
fs = require('fs');
yaml = require('js-yaml');
Logger = require('../../logger');
merge = require('merge');
N = require('nitroglycerin');
version = require('../../../package.json').version;
path = require('path');
tmplconv = require('tmplconv');
yamlCutter = require('yaml-cutter');
console.log('We are about to add a new Exosphere service to the application!\n');
ref$ = parseCommandLine(process.argv), data = ref$.data, questions = ref$.questions;
inquirer.prompt(questions).then(function(answers){
  var srcPath, targetPath, appConfig, e;
  data = merge(data, answers);
  srcPath = path.join(__dirname, '..', '..', '..', 'templates', 'add-service', data.templateName);
  targetPath = path.join(process.cwd(), data.serviceName);
  try {
    appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
  } catch (e$) {
    e = e$;
    console.log(e);
    throw e;
  }
  data.appName = appConfig.name;
  return tmplconv.render(srcPath, targetPath, {
    data: data
  }).then(function(){
    var options;
    options = {
      file: 'application.yml',
      root: 'services',
      key: data.serviceName,
      value: {
        location: "./" + data.serviceName
      }
    };
    return yamlCutter.insertHash(options, N(function(){
      return console.log(green("\ndone"));
    }));
  });
});
function serviceNames(){
  return fs.readdirSync(path.join(__dirname, '..', '..', '..', 'templates', 'add-service'));
}
function parseCommandLine(commandLineArgs){
  var data, questions, _, serviceType, serviceName, templateName, modelName, description;
  data = {};
  questions = [];
  _ = commandLineArgs[0], _ = commandLineArgs[1], _ = commandLineArgs[2], serviceType = commandLineArgs[3], serviceName = commandLineArgs[4], templateName = commandLineArgs[5], modelName = commandLineArgs[6], description = commandLineArgs[7];
  if (serviceName) {
    data.serviceName = serviceName;
  } else {
    questions.push({
      message: 'Name of the service to create:',
      type: 'input',
      name: 'serviceName',
      filter: function(input){
        return input.trim();
      },
      validate: function(input){
        return input.length > 0;
      }
    });
  }
  if (description) {
    data.description = description;
  } else {
    questions.push({
      message: 'Description:',
      type: 'input',
      name: 'description',
      filter: function(input){
        return input.trim();
      }
    });
  }
  if (templateName) {
    data.templateName = templateName;
  } else {
    questions.push({
      message: 'Type:',
      type: 'list',
      name: 'templateName',
      choices: serviceNames()
    });
  }
  if (modelName) {
    data.modelName = modelName;
  } else {
    questions.push({
      message: 'Name of the data model:',
      type: 'input',
      name: 'modelName',
      filter: function(input){
        return input.trim();
      }
    });
  }
  return {
    data: data,
    questions: questions
  };
}