// Generated by LiveScript 1.5.0
var green, inquirer, fs, yaml, merge, N, path, tmplconv, yamlCutter, ref$, data, questions;
green = require('chalk').green;
inquirer = require('inquirer');
fs = require('fs');
yaml = require('js-yaml');
merge = require('merge');
N = require('nitroglycerin');
path = require('path');
tmplconv = require('tmplconv');
yamlCutter = require('yaml-cutter');
console.log('We are about to create a new Exosphere service!\n');
ref$ = parseCommandLine(process.argv), data = ref$.data, questions = ref$.questions;
inquirer.prompt(questions).then(function(answers){
  var srcPath, targetPath, appConfig, error;
  data = merge(data, answers);
  srcPath = path.join(__dirname, '..', '..', '..', '..', '..', 'templates', 'add-service', data.templateName);
  targetPath = path.join(process.cwd(), '..', data.serviceName);
  try {
    appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
  } catch (e$) {
    error = e$;
    throw new Error("Creation of service '" + data.serviceName + "' has failed.");
  }
  data.appName = appConfig.name;
  return tmplconv.render(srcPath, targetPath, {
    data: data
  }).then(function(){
    var options;
    options = {
      file: 'application.yml',
      root: 'services',
      key: data.serviceName,
      value: {
        location: "../" + data.serviceName
      }
    };
    return yamlCutter.insertHash(options, N(function(){
      return console.log(green("\ndone"));
    }));
  });
});
function serviceNames(){
  return fs.readdirSync(path.join(__dirname, '..', '..', '..', '..', '..', 'templates', 'add-service'));
}
function parseCommandLine(commandLineArgs){
  var data, questions, _, serviceName, templateName, modelName, description;
  data = {};
  questions = [];
  _ = commandLineArgs[0], _ = commandLineArgs[1], _ = commandLineArgs[2], _ = commandLineArgs[3], serviceName = commandLineArgs[4], templateName = commandLineArgs[5], modelName = commandLineArgs[6], description = commandLineArgs[7];
  if (serviceName) {
    data.serviceName = serviceName;
  } else {
    questions.push({
      message: 'Name of the service to create',
      type: 'input',
      name: 'serviceName',
      filter: function(input){
        return input.trim();
      },
      validate: function(input){
        return input.length > 0;
      }
    });
  }
  if (templateName) {
    data.templateName = templateName;
  } else {
    questions.push({
      message: 'Type:',
      type: 'list',
      name: 'templateName',
      choices: serviceNames()
    });
  }
  if (modelName) {
    data.modelName = modelName;
  } else {
    questions.push({
      message: 'Name of the data model (leave blank if no model exists):',
      type: 'input',
      name: 'modelName',
      filter: function(input){
        return input.trim();
      }
    });
  }
  if (description) {
    data.description = description;
  } else {
    questions.push({
      message: 'Description:',
      type: 'input',
      name: 'description',
      filter: function(input){
        return input.trim();
      }
    });
  }
  return {
    data: data,
    questions: questions
  };
}