// Generated by LiveScript 1.5.0
var EventEmitter, fs, yaml, N, ObservableProcess, path, portReservation, ServiceRunner;
EventEmitter = require('events').EventEmitter;
fs = require('fs');
yaml = require('js-yaml');
N = require('nitroglycerin');
ObservableProcess = require('observable-process');
path = require('path');
portReservation = require('port-reservation');
ServiceRunner = (function(superclass){
  var prototype = extend$((import$(ServiceRunner, superclass).displayName = 'ServiceRunner', ServiceRunner), superclass).prototype, constructor = ServiceRunner;
  function ServiceRunner(name, config){
    var ref$;
    this.name = name;
    this.config = config;
    this.write = bind$(this, 'write', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(this.config.root, 'service.yml'), 'utf8'));
    (ref$ = this.serviceConfig.messages).sends == null && (ref$.sends = []);
    (ref$ = this.serviceConfig.messages).receives == null && (ref$.receives = []);
  }
  ServiceRunner.prototype.start = function(done){
    var this$ = this;
    return portReservation.getPort(N(function(port){
      var x$;
      this$.config.SERVICE_NAME = this$.name;
      this$.config.EXORELAY_PORT = port;
      x$ = new ObservableProcess(this$._createCommand(this$.serviceConfig.startup.command), {
        cwd: this$.config.root,
        env: this$.config,
        stdout: {
          write: this$.write
        },
        stderr: {
          write: this$.write
        }
      });
      x$.on('ended', function(){
        throw new Error("Service '" + this$.name + "' crashed");
      });
      x$.wait(this$.serviceConfig.startup['online-text'], function(){
        this$.emit('online', this$.name);
        return done();
      });
      return x$;
    }));
  };
  ServiceRunner.prototype._createCommand = function(command){
    if (this._isLocalCommand(command)) {
      command = path.join(this.config.root, command);
    }
    return command;
  };
  ServiceRunner.prototype._isLocalCommand = function(command){
    return command.substr(0, 2) === './';
  };
  ServiceRunner.prototype.write = function(text){
    return this.emit('output', {
      name: this.name,
      text: text
    });
  };
  return ServiceRunner;
}(EventEmitter));
module.exports = ServiceRunner;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}