// Generated by LiveScript 1.5.0
var AppSetup, ref$, cyan, dim, green, red, yaml, Logger, fs, version, appConfig, logger, x$, appSetup;
AppSetup = require('./app-setup');
ref$ = require('chalk'), cyan = ref$.cyan, dim = ref$.dim, green = ref$.green, red = ref$.red;
yaml = require('js-yaml');
Logger = require('../../logger');
fs = require('fs');
version = require('../../../package.json').version;
console.log(dim("Exosphere SDK " + version + "\n"));
appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
console.log("Setting up " + green(appConfig.name) + " " + cyan(appConfig.version) + "\n");
logger = new Logger(Object.keys(appConfig.services));
x$ = appSetup = new AppSetup(appConfig);
x$.on('start', function(name){
  return logger.log({
    name: 'exo-setup',
    text: "starting setup of '" + name + "'"
  });
});
x$.on('error', function(name, exitCode){
  console.log(red("setup of '" + name + "' failed with exit code " + exitCode));
  return process.exit(exitCode);
});
x$.on('output', function(data){
  data.text = data.text.replace('\n', '');
  return logger.log(data);
});
x$.on('finished', function(name){
  return logger.log({
    name: 'exo-setup',
    text: "setup of '" + name + "' finished"
  });
});
x$.on('setup-complete', function(){
  return logger.log({
    name: 'exo-setup',
    text: 'setup complete'
  });
});
x$.startSetup();