// Generated by LiveScript 1.5.0
var abbrev, red, fs, pkg, path, updateNotifier, commandName, commandHandlerPath;
abbrev = require('abbrev');
red = require('chalk').red;
fs = require('fs');
pkg = require('../package.json');
path = require('path');
updateNotifier = require('update-notifier');
updateNotifier({
  pkg: pkg
}).notify();
commandName = process.argv[2];
if (!commandName) {
  return missingCommand();
}
commandHandlerPath = __dirname + "/commands/" + abbrev(commandNames())[commandName] + "/cli.js";
fs.access(commandHandlerPath, function(err){
  switch (false) {
  case !err:
    return unknownCommand(commandName);
  }
  return require(commandHandlerPath);
});
function missingCommand(){
  console.log(red("Error: missing command\n"));
  return printUsage();
}
function unknownCommand(command){
  console.log(red("Error: unknown command '" + command + "'\n"));
  return printUsage();
}
function printUsage(){
  var i$, ref$, len$, command;
  console.log('Usage: exo <command> [options]\n');
  console.log('Available commands are:');
  for (i$ = 0, len$ = (ref$ = commandNames()).length; i$ < len$; ++i$) {
    command = ref$[i$];
    if (command === 'add') {
      console.log("* add [<service-name>] [<template-name>] [<model-name>] [<description>]");
    } else {
      console.log("* " + command);
    }
  }
  return console.log();
}
function commandNames(){
  return fs.readdirSync(path.join(__dirname, 'commands'));
}